#include "button.hpp"

using namespace Voltmeter;


void Button::SetState(bool newState, int32_t currentTimeMs)
{
    if (!initialized)
    {
        lastState = newState;
        initialized = true;
        return;
    }

    if (!lastState && newState)
    {
        pressTimeMs = currentTimeMs;
        longPressActive = false;
    }

    // Check if button was ever pressed.
    if (pressTimeMs >= 0)
    {
        if (!longPressActive)
        {
            if (newState && (currentTimeMs - pressTimeMs >= longPressTimeMs))
            {
                longPressActive = true;
                returnLongPress = true;
                pressTimeMs = currentTimeMs;
            }

            if (lastState && !newState)
            {
                returnShortPress = true;
            }
        }

        if (longPressActive && multipleLongPresses)
        {
            if (newState && (currentTimeMs - pressTimeMs >= longPressTimeMs / 2))
            {
                returnLongPress = true;
                pressTimeMs = currentTimeMs;
            }
        }
    }

    lastState = newState;
}


bool Button::WasPressed()
{
    if (returnShortPress)
    {
        returnShortPress = false;
        return true;
    }

    return false;
}


bool Button::WasLongPressed()
{
    if (returnLongPress)
    {
        returnLongPress = false;
        return true;
    }

    return false;
}