#pragma once

#include <stdint.h>
#include "voltage.hpp"


namespace Voltmeter::DisplayUtils
{
    constexpr uint8_t const CharBacklightLock = 0;
    constexpr uint8_t const CharWaveForm = 1;
    constexpr uint8_t const CharWarning = 2;
    constexpr uint8_t const CharDottedLine = 3;
    constexpr uint8_t const CharSpeaker = 4;
    constexpr uint8_t const CharVolume = 5;
    constexpr uint8_t const CharAutoRange = 6;
    
    void LoadChars();
    void LoadVolumeChar(uint8_t const level);
    void LoadWaveFormChar(WaveForm const waveform);
    void DisplayVoltage(Voltage const & voltage);
};