#pragma once

#include <stdint.h>


namespace Voltmeter::MathUtils
{
    constexpr uint16_t const Pow10(uint8_t power)
    {
        uint16_t result = 1;

        for (int i = 0; i < power; ++i)
        {
            result *= 10;
        }

        return result;
    }


    constexpr uint8_t Log10(int16_t value)
    {
        uint8_t result = 0;

        while (value >= 10)
        {
            value = value / 10;
            ++result;
        }

        return result;
    }


    template <typename T>
    constexpr T Abs(T x)
    {
        if (x >= 0)
        {
            return x;
        }
        
        return -x;
    }


    template <typename T>
    constexpr T Max(T a, T b)
    {
        if (a >= b)
        {
            return a;
        }
        
        return b;
    }
}